import time
import matplotlib
import sklearn.datasets
from tensorboardX.utils import figure_to_image

# TODO make sure tensorboard_utils are found here depending on your project structure
import session_11_hpc_tensorboard.tensorboard_utils as tensorboard_utils
import argparse
import torch
import numpy as np
import matplotlib.pyplot as plt

# pip install tensorflow
# pip install tensorboardX
# pip install argparse
# cmd: tensorboard --logdir=/abs/path/to/seq_default

parser = argparse.ArgumentParser(description='Model trainer')
parser.add_argument('-run_name', default=f'run_{time.time()}', type=str)
parser.add_argument('-sequence_name', default=f'seq_default', type=str)
parser.add_argument('-is_cuda', default=False, type=lambda x: (str(x).lower() == 'true'))
# TODO add more params
args = parser.parse_args()

#TODO add summary writer

for epoch in range(1, args.epochs + 1):
    print(f'simulated epoch: {epoch}')

    train_loss = -np.log(epoch/(args.epochs + 2))
    acc = np.log(epoch)/np.log(args.epochs + 1)

    #TODO add to scalar

    #TODO add hparams

    class_count = 3
    conf_matrix = np.zeros((class_count, class_count))
    for batch in range(16):
        y = torch.softmax(torch.randn((32, class_count)), dim=1)
        y_prim = torch.softmax(torch.randn((32, class_count)), dim=1)

        #TODO add conf_matrix calculation

    #TODO add plt figure
    plt.imshow(conf_matrix, interpolation='nearest', cmap=plt.get_cmap('Greys'))
    plt.xticks([0, 1, 2], ['Setosa', 'Virginica', 'ersicolor'])
    plt.yticks([0, 1, 2], ['Setosa', 'Virginica', 'ersicolor'])
    for x in range(class_count):
        for y in range(class_count):
            plt.annotate(
                str(round(100 * conf_matrix[x,y]/np.sum(conf_matrix[x]), 1)), xy=(y, x),
                horizontalalignment='center',
                verticalalignment='center',
                backgroundcolor='white'
            )
    plt.xlabel('True')
    plt.ylabel('Predicted')
    plt.show()

    #TODO add figure to tensorboard

    embeddings, classes = sklearn.datasets.make_blobs(n_samples=1000, n_features=128, centers=3)
    #TODO add embeddings to tensorboard
